from CAccount import CAccount
from SAccount import SAccount
from Customer import Customer

class Bank:
  accounts = [] # to hold both cheque and savings accounts
  customers = []# customers will have a link to one account

  @staticmethod
  def main():
    Bank.load_CAccounts() # for the first 8 customers
    Bank.load_SAccounts() # for the last 8 customers
    Bank.loadCustomerList() # also aggragates one ac for each customer

    # let us give the first customer a $100 for their Account
    amount = 100.00
    cus = Bank.customers[0]
    print (cus)  # display ac before transaction
    ac = cus.getAccObj()
    ac.deposit(amount)
    print (cus)  # display ac after transaction
    message = "You deposited " + str(amount)
    Bank.printReceipt(message, Bank.customers[0])

    # let us take $200 from  the second customer 
    amount = 200.00
    cus = Bank.customers[1]
    print (cus)
    ac = cus.getAccObj()
    ac.withdraw(amount)
    print (cus)
    message = "You withdrew $" + str(amount)
    Bank.printReceipt(message, Bank.customers[1])


  @staticmethod
  def printReceipt(message, customer):
      fr = open("BankingReceipt.txt", "a") #append 
      fr.write("\n\n******* BankingReceipt *************\n")
      fr.write(message)
      fr.write(str(customer))
      fr.close()

   

  @staticmethod
  def load_CAccounts():
    fr = open("text/CAccounts.txt", "r")
    for line in fr:
      line = line.rstrip("\n")
      temp = line.split(";") # generate a list of 3 or 4 items
      c = None      
      if len(temp) == 3:
        c = CAccount(int(temp[0]), temp[1], float(temp[2]))
      elif len(temp) == 4:
        c = CAccount(int(temp[0]), temp[1], float(temp[2]), float(temp[3]))
      else:
        print("load_CAccounts could not analyse " + line)
      if c != None:
        Bank.accounts.append(c)
            
    fr.close()

  @staticmethod
  def load_SAccounts():
    fr = open("text/SAccounts.txt", "r")
    for f in fr:
            f = f.rstrip("\n")
            temp = f.split(";")
            
            if len(temp) == 3:
                c = SAccount(int(temp[0]), temp[1], float(temp[2]))
                Bank.accounts.append(c)
            else:
                c = SAccount(int(temp[0]), temp[1], float(temp[2]), float(temp[3]))
                Bank.accounts.append(c)
            
    fr.close()



  @staticmethod
  def loadCustomerList():
    accountIndex = 0  # for indexing sequentially the next ac to the next customer
    fr = open("text/Customers.txt", "r")
    for f in fr:
      f = f.rstrip("\n")
      temp = f.split(";")
      #custNo, custNm, age, city, accObj -  copied from Customer class
      c = Customer(int(temp[0]), temp[1], int(temp[2]), temp[3], Bank.accounts[accountIndex])
      Bank.customers.append(c)
      accountIndex += 1 # increment to point to the next account
               
    fr.close()

Bank.main()




     